/**
 * .jsx for Adobe apps. Marat Shagiev. Date: 24.10.13, Time: 23:55
 */

var doc = activeDocument;
var lays = doc.layers;

/*********************
 **  THE SCRIPT
 *********************/

// скрыть слои содержащие текст
for (var i = 0; i < lays.length; i++) {
  if (isTextOnLayer(lays[i])) {
    lays[i].visible = false;
  }
}

// экспорт в джипег
expToJpg();

// показать слои с текстом и перевести текста в кривые
for (var i = 0; i < lays.length; i++) {
  if (isTextOnLayer(lays[i])) {
    lays[i].visible = true;
    for (var j = 0; j < lays[i].textFrames.length; j++) {
      lays[i].textFrames[j].createOutline();
    }
  }
}

/*********************
 **  THE LIBRARY
 *********************/

function expToJpg(suffix/*приписка в конце имени джипега, опционально*/) {
  var props = new ExportOptionsJPEG();
  var type = ExportType.JPEG;
  var fullPath = getFullName(suffix);
  var f = new File(fullPath);

  props.qualitySetting = 30;
  props.horizontalScale = 100;
  props.verticalScale = 100;

  app.activeDocument.exportFile(f, type, props);

}

function isTextOnLayer(layer) {
  try {
    return  layer.textFrames[0];
  } catch (e) {
    // alert('Error line: ' + e.line + '\n' + 'Error message: ' + e.message);
  }
  return false;
}

function getFullName(suffix/*приписка в конце имени джипега, опционально*/) {

  var doc = activeDocument;
  var fullPath, fileName;

// имя файла без расширения(если документ только создан и еще не сохранен)
  (doc.path.exists) ? fileName = doc.name.slice(0, -(getFileExt().length)) : fileName = doc.name;
  // если документ только создан и еще не сохранен, то джипег улетит в "Мои документы"
  if (!doc.path.exists) {
    fullPath = Folder.myDocuments + '/' + replaceSpaceOnDash(fileName) + replaceSpaceOnDash(suffix) + '.jpg';
  } else {
    // если документ лежит на диске, то джипег ляжет рядышком
    fullPath = doc.path.fullName + '/' + replaceSpaceOnDash(fileName) + replaceSpaceOnDash(suffix) + '.jpg';
  }

  return fullPath;
}

// возвращает расширение файла
function getFileExt() {
  var doc = activeDocument;
  return (doc.name.lastIndexOf('.') == -1) ? -1 : doc.name.slice(doc.name.lastIndexOf('.'));
}

// замена всех пробелов в строке на дефисы
function replaceSpaceOnDash(str) {
  str = '' + str;
  var newStr = '';
  for (var l = 0; l < str.length; l++) {
    (str.charAt(l) == ' ') ? newStr += '-' : newStr += str[l];
  }
  return newStr;
}